# HG changeset patch
# User Christophe Capon <christophe.capon@vilogia.fr>
# Date 1270092698 -7200
# Branch 5.3.0
# Node ID 30115d3f222047f114adb2bf6a9d2a27a987772e
# Parent  02a9f35407df4c98bd1735caf6c531827562714d
Allow to select alert provider order in the alert mail

diff -r 02a9f35407df -r 30115d3f2220 nuxeo-platform-alert-core/src/main/java/org/nuxeo/ecm/alert/core/AlertManagementServiceImpl.java
--- a/nuxeo-platform-alert-core/src/main/java/org/nuxeo/ecm/alert/core/AlertManagementServiceImpl.java	Thu Apr 01 05:25:45 2010 +0200
+++ b/nuxeo-platform-alert-core/src/main/java/org/nuxeo/ecm/alert/core/AlertManagementServiceImpl.java	Thu Apr 01 05:31:38 2010 +0200
@@ -20,8 +20,12 @@
 package org.nuxeo.ecm.alert.core;
 
 import java.io.BufferedReader;
+import java.io.IOException;
 import java.io.InputStream;
 import java.io.InputStreamReader;
+import java.net.MalformedURLException;
+import java.net.URL;
+import java.util.ArrayList;
 import java.util.Collection;
 import java.util.HashMap;
 import java.util.Iterator;
@@ -29,9 +33,12 @@
 import java.util.Map;
 import java.util.Map.Entry;
 
+import javax.xml.parsers.ParserConfigurationException;
+
 import org.apache.commons.logging.Log;
 import org.apache.commons.logging.LogFactory;
 import org.jboss.seam.international.Messages;
+import org.nuxeo.common.xmap.XMap;
 import org.nuxeo.ecm.alert.Alert;
 import org.nuxeo.ecm.alert.AlertContext;
 import org.nuxeo.ecm.alert.AlertEvent;
@@ -79,8 +86,12 @@
 
     private static final Log log = LogFactory.getLog(AlertManagementServiceImpl.class);
 
+    private Boolean rankLoaded = false;
+
     private Map<String, AlertProvider> alertProviders = new HashMap<String, AlertProvider>();
 
+    private List<AlertProvider> sortedProviders = new ArrayList<AlertProvider>();
+
     private RenderingService rs = null;
 
     private EmailHelper helper = null;
@@ -93,6 +104,17 @@
 
     private static UserSettingsService userSettingsService = null;
 
+    private static XMap xmap = null;
+
+    private void initXmap() {
+
+        if (xmap == null) {
+            log.info("Initialize XMap for configuration file");
+            xmap = new XMap();
+            xmap.register(AlertProviderRanking.class);
+        }
+    }
+
     private static UserSettingsService getUserSettingsService()
             throws Exception {
 
@@ -111,6 +133,8 @@
 
         try {
 
+            loadRanks();
+
             CoreSession coreSession = ctx.getEvent().getContext().getCoreSession();
 
             init(ctx);
@@ -132,6 +156,67 @@
 
     }
 
+    private void loadRanks() {
+
+        if (!rankLoaded) {
+
+            try {
+
+                initXmap();
+
+                AlertProviderRanking rank = loadRankingFromConfig();
+
+                if (null != rank) {
+                    
+                    for (String p : rank.provider) {
+                        if (alertProviders.containsKey(p)) {
+                            AlertProvider pr = alertProviders.get(p);
+                            if (!sortedProviders.contains(pr))
+                                sortedProviders.add(pr);
+                        }
+                    }
+
+                }
+                
+                Iterator<Entry<String, AlertProvider>> it = alertProviders.entrySet().iterator();
+                while (it.hasNext()) {
+                    Entry<String, AlertProvider> item = it.next();
+                    if (!sortedProviders.contains(item.getValue()))
+                        sortedProviders.add(item.getValue());
+                }
+
+            } catch (Exception e) {
+
+                sortedProviders = new ArrayList<AlertProvider>();
+
+                Iterator<Entry<String, AlertProvider>> it = alertProviders.entrySet().iterator();
+                while (it.hasNext()) {
+                    Entry<String, AlertProvider> item = it.next();
+                    sortedProviders.add(item.getValue());
+                }
+
+            }
+
+            rankLoaded = true;
+        }
+
+    }
+
+    private AlertProviderRanking loadRankingFromConfig() {
+
+        AlertProviderRanking result = null;
+
+        try {
+            URL url = getClass().getResource(
+                    "/config/alert-providers-ranking.xml");
+            Object[] config = (Object[]) xmap.loadAll(url);
+            if (config.length > 0)
+                result = (AlertProviderRanking) config[0];
+        } catch (Exception e) {
+        }
+        return result;
+    }
+
     private void init(AlertContext ctx) throws Exception {
 
         if (rs == null) {
@@ -282,7 +367,7 @@
             throws Exception {
 
         DocumentModel userSettingsDoc = getUserSettingsService().getUserSettings(
-                coreSession, "AlertSettings").get(0);
+                coreSession, userName, "AlertSettings").get(0);
         AlertSettingsWrapper settings = new AlertSettingsWrapper(
                 userSettingsDoc);
 
@@ -303,7 +388,10 @@
 
         if (go) {
 
-            Iterator<Entry<String, AlertProvider>> iter = alertProviders.entrySet().iterator();
+            Iterator<AlertProvider> iter = sortedProviders.iterator();
+
+            // Iterator<Entry<String, AlertProvider>> iter =
+            // alertProviders.entrySet().iterator();
 
             StringBuilder bdr = new StringBuilder();
 
@@ -311,10 +399,10 @@
 
             while (iter.hasNext()) {
 
-                Entry<String, AlertProvider> item = iter.next();
+                AlertProvider item = iter.next();
 
-                String render = item.getValue().renderAlerts(coreSession, rs,
-                        userName, alerts, userSettingsDoc, ctx);
+                String render = item.renderAlerts(coreSession, rs, userName,
+                        alerts, userSettingsDoc, ctx);
 
                 bdr.append(render);
 
diff -r 02a9f35407df -r 30115d3f2220 nuxeo-platform-alert-core/src/main/java/org/nuxeo/ecm/alert/core/AlertProviderRanking.java
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/nuxeo-platform-alert-core/src/main/java/org/nuxeo/ecm/alert/core/AlertProviderRanking.java	Thu Apr 01 05:31:38 2010 +0200
@@ -0,0 +1,15 @@
+package org.nuxeo.ecm.alert.core;
+
+import java.util.ArrayList;
+import java.util.List;
+
+import org.nuxeo.common.xmap.annotation.XNodeList;
+import org.nuxeo.common.xmap.annotation.XObject;
+
+@XObject("providerRanking")
+public class AlertProviderRanking {
+
+    @XNodeList(value="provider", type=ArrayList.class, componentType=String.class)
+    public List<String> provider;
+
+}
